#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <mpi.h>

int main( int argc, char *argv[] )
{
    int merr;
    int rank, namelen;
    char   processor_name[MPI_MAX_PROCESSOR_NAME];
    char port[MPI_MAX_PORT_NAME];
    MPI_Comm comm_intra, comm_aux, comm_agg, comm_world, comm_inter;


    MPI_Init(&argc, &argv);

    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    MPI_Get_processor_name(processor_name,&namelen);

    MPI_Open_port(MPI_INFO_NULL, port);
    merr = MPI_Publish_name( "serverA" , MPI_INFO_NULL, port );
    if (merr) {
        perror("Error at initializing IOSERVER\n");
    }
    MPI_Comm_dup(MPI_COMM_WORLD, &comm_world);

    MPI_Comm_accept(port, MPI_INFO_NULL, 0, MPI_COMM_WORLD, &comm_inter);

    /* We create a intracommunicator between client and serverA   */        
    MPI_Intercomm_merge( comm_inter, 1, &comm_agg );

    /* We get a new intercommunicator including serverB  */
    MPI_Intercomm_create( comm_agg , 0, MPI_COMM_NULL, 0, 12345 , &comm_aux ); 

    /* Finally intracommunicator including all the peers  */
    MPI_Intercomm_merge( comm_aux, 1, &comm_agg );
 
    /* Some code here  */

    MPI_Finalize();
    return 0;
} 
